#!/usr/bin/env
# encoding: utf-8
# -*- coding: utf-8 -*-
# vim:set fileencoding=utf-8:
# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
# This File is From Theopse Organization(mail@theopse.org)
# Licensed under BSD-2-Caluse
# File: .gitlab-ci.yml (theopse/existence/algorithms/sort.ex/.gitlab-ci.yml)
# Content:
# Copyright (c) 2023 Theopse Organization All rights reserved
# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
---
stages:
  - test

.elixir: &elixir
  image: elixir:1.14.0-slim
  before_script:
    - apt-get update
    - apt-get upgrade -y
    - mix local.hex --force
    - mix local.rebar --force
    - mix deps.get --only $MIX_ENV
  
.elixir.musl: &elixir
  image: elixir:1.14.0-alpine
  before_script:
    - apk update
    - apk upgrade
    - mix local.hex --force
    - mix local.rebar --force
    - mix deps.get --only $MIX_ENV

lint:
  extends: .elixir
  stage: test
  variables:
    MIX_ENV: test
  script:
    - mix compile --warnings-as-errors --force
    - mix format --check-formatted

test:
  extends: .elixir
  stage: test
  variables:
    MIX_ENV: test
  script:
    - mix test

test.musl:
  extends: .elixir.musl
  stage: test
  variables:
    MIX_ENV: test
  script:
    - mix test

sast:
  stage: test
  artifacts:
    paths: 
      - gl-sast-report.json

include:
  - template: Security/SAST.gitlab-ci.yml
